Index: trunk/kernel/ksh/miniShellIo.c
===================================================================
--- trunk/kernel/ksh/miniShellIo.c	(revision 1)
+++ trunk/kernel/ksh/miniShellIo.c	(revision 1)
@@ -0,0 +1,171 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <ctype.h>
+#include <libk.h>
+#include <string.h>
+#include <thread.h>
+#include <cluster.h>
+#include <sys-vfs.h>
+#include <driver.h>
+#include <device.h>
+#include <kminiShell.h>
+#include <stdarg.h>
+
+kdmsg_channel_t ksh_tty = {{.id = 0}};
+ 
+char getChar()
+{
+  struct device_s *tty;
+  dev_request_t rq;
+  char ch;
+  size_t size;
+  
+  ch = 0;
+  size = 0;
+  tty = ttys_tbl[ksh_tty.id];
+
+  while(size != 1 && size != -1)
+  {
+    rq.dst = (uint32_t*) &ch;
+    rq.count = 1;
+    rq.flags = 0;
+    size = tty->op.dev.read(tty, &rq);
+  }
+  return ch;
+}
+
+
+ssize_t ksh_getLine(char *buff, int count)
+{
+  struct device_s *tty;
+  dev_request_t rq;
+  ssize_t size;
+ 
+  tty = ttys_tbl[ksh_tty.id];
+
+  rq.dst = (uint32_t*) buff;
+  rq.count = count;
+  rq.flags = 0;
+  size = tty->op.dev.read(tty, &rq);
+  return size;
+}
+
+void ksh_write(void *buff, size_t size)
+{
+  struct device_s *tty;
+  dev_request_t rq;
+  
+  tty = ttys_tbl[ksh_tty.id];
+  rq.src = buff;
+  rq.count = size;
+  rq.flags = 0;
+  (void)tty->op.dev.write(tty, &rq);
+}
+
+static char ksh_msg_buff[MSG_STR_LEN];
+
+void ksh_print(const char *fmt, ...)
+{
+  va_list ap;
+  int count;
+
+  va_start (ap, fmt);
+  count = iprintk(&ksh_msg_buff[0], current_cid, 1, (char *) fmt, ap);
+  assert(count < (MSG_STR_LEN-1));
+  va_end (ap);
+  count = (count < (MSG_STR_LEN -1)) ? count : MSG_STR_LEN - 1;
+  ksh_msg_buff[count + 1] = 0;
+  ksh_write(ksh_msg_buff, count);
+}
+
+void getString(char *buff,size_t size)
+{
+  char ch = 0;
+  char *str = buff;
+  char *val = NULL;
+  char line[128];
+  char *line_ptr = &line[0];
+  ssize_t count,i;
+  
+
+  while(size > 0)
+  {
+    count = ksh_getLine(line_ptr,128);
+    i=0;
+
+    while((count > 0) && (size > 0))
+    {
+      ch=line[i++];
+      
+      if(ch == '\r')
+	continue;
+
+      if(ch == '\n')
+	goto GETSTRING_END;
+
+      if(!isprint(ch))
+      {
+	if((ch == 0x7F) || (ch == 0x08))
+	  str--;
+	count ++;
+	size ++;
+	continue;
+      }
+
+      *str ++ = ch;
+      ch = 0;
+      count --;
+      size --;
+    }
+  }
+  
+ GETSTRING_END:
+  val = buff;
+  *str = 0;
+}
+
+void cmdLineAnalyser(ms_args_t *args)
+{
+  char buff[128];
+  char *str = &buff[0];
+  char *arg = NULL;
+  uint_t i;
+
+  getString(buff,128);
+  i=0;
+
+  while((*str != '\0') && (i < MS_MAX_ARG_LEN))
+  {
+    while((*str) && (isspace(*str))) str++;
+    
+    if(!(*str)) break;
+   
+    arg = args->argv[i];
+ 
+    while((*str) && (!isspace(*str))) 
+      *arg++ = *str ++;
+
+    i++; *arg = 0;
+  }
+  args->argv[i][0] = 0;
+  args->argc = i;
+}
Index: trunk/kernel/ksh/mkdir_func.c
===================================================================
--- trunk/kernel/ksh/mkdir_func.c	(revision 1)
+++ trunk/kernel/ksh/mkdir_func.c	(revision 1)
@@ -0,0 +1,46 @@
+/*
+	 This file is part of MutekP.
+	
+	 MutekP is free software; you can redistribute it and/or modify it
+	 under the terms of the GNU General Public License as published by
+	 the Free Software Foundation; either version 2 of the License, or
+	 (at your option) any later version.
+	
+	 MutekP is distributed in the hope that it will be useful, but
+	 WITHOUT ANY WARRANTY; without even the implied warranty of
+	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+	 General Public License for more details.
+	
+	 You should have received a copy of the GNU General Public License
+	 along with MutekP; if not, write to the Free Software Foundation,
+	 Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+	
+	 UPMC / LIP6 / SOC (c) 2008
+	 Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <stdint.h>
+#include <vfs.h>
+#include <kminiShell.h>
+ 
+error_t mkdir_func(void *param)
+{
+	ms_args_t *args;
+	struct ku_obj kuo;
+	error_t err;
+	uint32_t argc;
+	uint32_t i;
+	
+	args = (ms_args_t *) param;
+	argc = args->argc;
+	err = 0;
+	
+	for(i=1; i< argc; i++)
+	{
+		KK_BUFF(kuo, args->argv[i]); 
+		if((err=vfs_mkdir(ms_n_cwd, &kuo,0)))
+			return err;
+	}
+	return 0;
+}
+
Index: trunk/kernel/ksh/mkfifo_func.c
===================================================================
--- trunk/kernel/ksh/mkfifo_func.c	(revision 1)
+++ trunk/kernel/ksh/mkfifo_func.c	(revision 1)
@@ -0,0 +1,52 @@
+/*
+	 This file is part of MutekP.
+	
+	 MutekP is free software; you can redistribute it and/or modify it
+	 under the terms of the GNU General Public License as published by
+	 the Free Software Foundation; either version 2 of the License, or
+	 (at your option) any later version.
+	
+	 MutekP is distributed in the hope that it will be useful, but
+	 WITHOUT ANY WARRANTY; without even the implied warranty of
+	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+	 General Public License for more details.
+	
+	 You should have received a copy of the GNU General Public License
+	 along with MutekP; if not, write to the Free Software Foundation,
+	 Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+	
+	 UPMC / LIP6 / SOC (c) 2008
+	 Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <stdint.h>
+#include <vfs.h>
+#include <kminiShell.h>
+ 
+error_t mkfifo_func(void *param)
+{
+
+	return ENOSYS;
+#if 0
+	ms_args_t *arg;
+	struct ku_obj kuo;
+	error_t err;
+	uint32_t argc;
+	uint32_t i;
+
+	arg  = (struct ms_argument_s *) param;
+	argc = arg->argc;
+	argv = &arg->argv[0];
+	err  = 0;
+	
+	for(i=0; i< argc; i++)
+	{
+		KK_BUFF(kuo, argv[i]); 
+	 
+		if((err=vfs_mkfifo(ms_n_cwd, &kuo, 0)))
+			return err;
+	}
+#endif
+
+	return 0;
+}
Index: trunk/kernel/ksh/ppm_func.c
===================================================================
--- trunk/kernel/ksh/ppm_func.c	(revision 1)
+++ trunk/kernel/ksh/ppm_func.c	(revision 1)
@@ -0,0 +1,66 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <kminiShell.h>
+#include <system.h>
+#include <ppm.h>
+#include <kdmsg.h>
+#include <page.h>
+#include <thread.h>
+#include <cluster.h>
+
+error_t ppm_func(void *param)
+{
+#if 0
+	uint_t i,j;
+	register struct page_s *pages_tbl;
+	struct ppm_s *ppm;
+	uint_t cluster_nr;
+
+	cluster_nr = arch_onln_cluster_nr();
+#endif
+
+	//for(i=0; i < cluster_nr; i++)
+		ppm_print(&current_cluster->ppm);
+
+//FIXME
+#if 0
+	for(j=0; j < cluster_nr; j++)
+	{
+		ppm = &clusters_tbl[j].cluster->ppm;
+		pages_tbl = ppm->pages_tbl;
+	
+		for(i=0; i < ppm->pages_nr; i++)
+		{
+			if(pages_tbl[i].flags != 0x5)
+	printk(WARNING,"WARNING: unexpected flags %x for page %x [i=%d]\n",
+	       pages_tbl[i].flags,ppm_page2addr(&pages_tbl[i]),i);
+		}
+	
+		for(i=0; i < KMEM_TYPES_NR; i++)
+		{
+			if(clusters_tbl[j].cluster->keys_tbl[i] != NULL)
+	kcm_print(clusters_tbl[j].cluster->keys_tbl[i]);
+		}
+	}
+#endif
+	return 0;
+}
Index: trunk/kernel/ksh/ps.c
===================================================================
--- trunk/kernel/ksh/ps.c	(revision 1)
+++ trunk/kernel/ksh/ps.c	(revision 1)
@@ -0,0 +1,133 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+   Copyright (c) 2009,2010,2011,2012,2013,2014,2015 UPMC Sorbonne Universites
+*/
+
+#include <list.h>
+#include <thread.h>
+#include <pid.h>
+#include <task.h>
+#include <cpu.h>
+#include <vfs.h>
+#include <rwlock.h>
+#include <system.h>
+#include <wait_queue.h>
+
+#define ksh_print(x, ...) printk(INFO,x, __VA_ARGS__)
+
+void ps_print_task(struct task_s *task, uint_t *usr_nr, uint_t *sys_nr, uint_t *tasks_nr)
+{
+  struct thread_s *thread;
+  struct list_entry *iter;
+  struct list_entry *th_root;
+  char *cmd;
+  uint_t ppid;
+
+  if(task != NULL)
+  {
+    th_root = &task->th_root;
+    
+    ppid = PID_MIN_GLOBAL;
+    cmd = "N/A";
+
+    if(task->pid != PID_MIN_GLOBAL)
+      ppid = task->parent;
+    
+    if(task->state == TASK_CREATE)
+      cmd = "Under-Creation";
+    else
+      if(VFS_FILE_IS_NULL(task->bin))
+      {
+	//cmd = vfs_get_file_name(task->bin);
+	cmd = "ENOTSUP";
+      }
+
+    printk(INFO,"\n[PID] %d [PPID] %d [Children] %d [Command] %s\n",
+	   task->pid, 
+	   ppid,
+	   atomic_get(&task->childs_nr),
+	   cmd);
+
+    if(task->state == TASK_CREATE)
+      return;
+
+    spinlock_lock(&task->th_lock);
+
+    list_foreach_forward(th_root, iter)
+    {
+      thread = list_element(iter, struct thread_s, rope);
+      assert(thread->signature == THREAD_ID);
+
+      ksh_print("  |__ [TID] %x [ORD] %d [%s] [CPU] %d [TICKs] %d [Sched] %d [tm_sys] %u [tm_usr] %u [tm_sleep] %u %s [ %s ]\n",
+		thread,
+		thread->info.order,
+		thread_get_attr_name(thread->type), 
+		thread_current_cpu(thread)->gid, 
+		thread->ticks_nr,
+		thread->info.sched_nr,
+		thread->info.tm_sys,
+		thread->info.tm_usr,
+		thread->info.tm_sleep,
+		thread_get_state_name(thread->state), 
+		(thread->info.queue == NULL) ? "N/A" : thread->info.queue->name);
+
+      if(thread->type == PTHREAD)
+	*usr_nr = *usr_nr + 1;
+      else
+	*sys_nr = *sys_nr + 1;
+    }
+
+    if(!(list_empty(th_root)))
+      *tasks_nr = *tasks_nr + 1;
+
+    spinlock_unlock(&task->th_lock);
+  }
+}
+
+error_t ps_func(void *param)
+{
+  uint_t usr_nr;
+  uint_t sys_nr;
+  uint_t tasks_nr;
+  uint_t pid;
+  struct task_locator_s *task_locator;
+
+  usr_nr = 0;
+  sys_nr = 0;
+  tasks_nr = 0;
+
+  ksh_print("\nOn cluster %u:\n", current_cid);
+
+  tasks_manager_lock();
+  /* Don't print task0, it's irrelevant */
+  for(pid=PID_MIN_GLOBAL+1; pid <= PID_MAX_GLOBAL; pid ++)
+  {
+    task_locator = task_lookup(pid);
+    if ( task_locator->cid != CID_NULL )
+            ps_print_task(task_locator->task, &usr_nr, &sys_nr, &tasks_nr);
+  }
+  tasks_manager_unlock();
+
+  ksh_print("\nTotal Active        Tasks   : %d\n", tasks_nr);
+  ksh_print("Total Active User   Threads : %d\n", usr_nr);
+  ksh_print("-----------------\n", NULL);
+  
+  return 0;
+}
Index: trunk/kernel/ksh/pwd_func.c
===================================================================
--- trunk/kernel/ksh/pwd_func.c	(revision 1)
+++ trunk/kernel/ksh/pwd_func.c	(revision 1)
@@ -0,0 +1,40 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <stdint.h>
+#include <vfs.h>
+#include <libk.h>
+#include <kminiShell.h>
+ 
+error_t pwd_func(void *param)
+{
+	error_t err;
+	char buff[128];
+	struct ku_obj ku_buff;
+
+	KK_SZ_BUFF(ku_buff, buff, 128);
+	err = vfs_get_path(ms_n_cwd, &ku_buff);
+
+	ksh_print("%s\n", &buff[0]);
+
+	return err;
+}
+
Index: trunk/kernel/ksh/rm.c
===================================================================
--- trunk/kernel/ksh/rm.c	(revision 1)
+++ trunk/kernel/ksh/rm.c	(revision 1)
@@ -0,0 +1,47 @@
+/*
+	 This file is part of MutekP.
+	
+	 MutekP is free software; you can redistribute it and/or modify it
+	 under the terms of the GNU General Public License as published by
+	 the Free Software Foundation; either version 2 of the License, or
+	 (at your option) any later version.
+	
+	 MutekP is distributed in the hope that it will be useful, but
+	 WITHOUT ANY WARRANTY; without even the implied warranty of
+	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+	 General Public License for more details.
+	
+	 You should have received a copy of the GNU General Public License
+	 along with MutekP; if not, write to the Free Software Foundation,
+	 Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+	
+	 UPMC / LIP6 / SOC (c) 2008
+	 Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <stdint.h>
+#include <vfs.h>
+#include <kminiShell.h>
+ 
+error_t rm_func(void *param)
+{
+	ms_args_t *args;
+	struct ku_obj kuo;
+	error_t err;
+	uint32_t argc;
+	uint32_t i;
+
+	args  = (ms_args_t *) param;
+	argc = args->argc;
+	err = 0;
+	
+	for(i=1; i< argc; i++)
+	{
+		KK_BUFF(kuo, args->argv[i]); 
+		if((err=vfs_unlink(ms_n_cwd, &kuo)))
+			return err;
+	}
+
+	return 0;
+}
+
Index: trunk/kernel/ksh/sgiImg.h
===================================================================
--- trunk/kernel/ksh/sgiImg.h	(revision 1)
+++ trunk/kernel/ksh/sgiImg.h	(revision 1)
@@ -0,0 +1,59 @@
+/*
+   This file is part of MutekP.
+  
+   MutekP is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+  
+   MutekP is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+  
+   You should have received a copy of the GNU General Public License
+   along with MutekP; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+  
+   UPMC / LIP6 / SOC (c) 2008
+   Copyright Ghassan Almaless <ghassan.almaless@lip6.fr>
+*/
+
+#ifndef _SGI_IMG_H_
+#define _SGI_IMG_H_
+
+#include <stdint.h>
+
+#define SGI_ALIGN4(val)				\
+  (((val) & 0x000000FF) << 24  |		\
+   ((val) & 0x0000FF00) << 8   |		\
+   ((val) & 0x00FF0000) >> 8   |		\
+   (val) >> 24)
+
+#define SGI_ALIGN2(val)				\
+  (((val) & 0x00FF)     << 8   |		\
+   (val) >> 8)
+
+#define SGI_TO_LE2(val)				\
+  (((val) & 0xFF00)     >> 8   |		\
+   (val) << 8)
+
+struct sgi_info_s
+{
+  uint16_t   magic;
+  uint8_t    storage;
+  uint8_t    bpc;
+  uint16_t   dimension;
+  uint16_t   x_size;
+  uint16_t   y_size;
+  uint16_t   z_size;
+  uint32_t   pix_min;
+  uint32_t   pix_max;
+  uint32_t   dummy1;
+  uint8_t    img_name[80];
+  uint32_t   color_map;
+  uint8_t    dummy2[404];
+} __attribute__ ((packed));
+
+
+#endif
Index: trunk/kernel/libk/bits.c
===================================================================
--- trunk/kernel/libk/bits.c	(revision 690)
+++ trunk/kernel/libk/bits.c	(revision 1)
@@ -1,7 +1,7 @@
 /*
- * bits.c - bitmap API implementation
+ * bits.c - bits manipulation functions implementation
  *
  * Author  Ghassan Almaless (2008,2009,2010,2011,2012)
- *         Alain Greiner    (2016,2017,2018,2019,2020)
+ *         Alain Greiner    (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -23,22 +23,6 @@
  */
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <bits.h>
-
-//////////////////////////////////////////////////////////////////////////////
-//////////////     local access functions     ///////////////////////////////
-//////////////////////////////////////////////////////////////////////////////
-
-////////////////////////////////////
-void bitmap_init( bitmap_t * bitmap,
-                  uint32_t   len )
-{
-    uint32_t word;
-    uint32_t nwords = BITMAP_SIZE( len );
-    for( word = 0 ; word < nwords ; word++ )
-    {
-        bitmap[word] = 0;
-    }
-}  // end bitmap_init()
 
 //////////////////////////////////////////
@@ -46,6 +30,6 @@
                         uint32_t   index )
 {
-	uint32_t  word = index >> 5;
-	uint32_t  bit  = index & 0x1F;
+	uint32_t  word = index / 32;
+	uint32_t  bit  = index % 32;
 
 	bitmap[word] |= ( 1 << bit );
@@ -56,6 +40,6 @@
                           uint32_t   index )
 {
-	uint32_t  word = index >> 5;
-	uint32_t  bit  = index & 0x1F;
+	uint32_t  word = index / 32;
+	uint32_t  bit  = index % 32;
 
 	bitmap[word] &= ~( 1 << bit );
@@ -66,44 +50,9 @@
                             uint32_t   index )
 {
-	uint32_t  word = index >> 5;
-	uint32_t  bit  = index & 0x1F;
-
-	return (bitmap[word] & ( 1 << bit )) != 0;
-}
-
-/////////////////////////////////////////
-uint32_t bitmap_alloc( bitmap_t * bitmap,
-                       uint32_t   size )
-{
-    uint32_t max_word;
-    uint32_t max_bit; 
-	uint32_t word;
-	uint32_t bit;
- 
-    if( size )
-    {
-        max_word = ( (size-1) >>5 ) + 1;
-
-        for( word = 0 ; word < max_word ; word++ )
-	    {
-            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
-
-		    if(bitmap[word] != 0XFFFFFFFF)
-		    {
-			    for(bit = 0 ; bit < max_bit ; bit++)
-			    {
-				    if( (bitmap[word] & (1 << bit)) == 0 )
-                    {
-                        bitmap[word] |= (1 << bit);
-                        return (word*32 + bit);
-                    }
-			    }
-            }
-		}
-	}
-
-	return -1;
-
-}  // end bitmap_alloc()
+	uint32_t  word = index / 32;
+	uint32_t  bit  = index % 32;
+
+	return (bitmap[word] & ( 1 << bit )) && 1;
+}
 
 //////////////////////////////////////////
@@ -120,7 +69,5 @@
 		if((len + bit) >= 32)
 		{
-            if( bit == 0 ) val = 0xFFFFFFFF;
-            else           val = (uint32_t)((1 << (32 - bit)) - 1);
-
+			val = (bit == 0) ? 0xFFFFFFFF : (1 << (32 - bit)) - 1;
 			bitmap[word] |= (val << bit);
 			word++;
@@ -134,5 +81,5 @@
 		}
 	}
-}  // bitmap_set_range()
+}
 
 ///////////////////////////////////////////
@@ -149,7 +96,5 @@
 		if((len + bit) >= 32)
 		{
-            if( bit == 0 ) val = 0xFFFFFFFF;
-            else           val = (uint32_t)((1 << (32 - bit)) - 1);
-
+			val = (bit == 0) ? 0xFFFFFFFF : (1 << (32 - bit)) - 1;
 			bitmap[word] &= ~(val << bit);
 			word++;
@@ -163,5 +108,5 @@
 		}
 	}
-}  // bitmap_clear_range()
+}
 
 ///////////////////////////////////////
@@ -170,36 +115,28 @@
                       uint32_t   size )
 {
-    uint32_t max_word;
 	uint32_t word = index / 32;  
 	uint32_t bit  = index % 32; 
  
-    if( index < size )
-    {
-	    if( bit != 0 )
-	    {
-		    for( ; bit < 32; bit++)
-		    {
-			    if((bitmap[word] & (1 << bit)) ) return (word*32 + bit);
-	  	    }
-		    word++;
-	    }
-
-        max_word = ( (size-1) >>5 ) + 1;
-
-        for( ; word < max_word ; word++ )
-	    {
-		    if(bitmap[word] != 0)
-		    {
-			    for(bit = 0 ; bit < 32 ; bit++)
-			    {
-				    if( bitmap[word] & (1 << bit) ) return (word*32 + bit);
-			    }
-            }
-		}
-	}
-
-	return -1;
-
-}  // bitmap_ffs2()
+	if(bit != 0)
+	{
+		for(; bit < 32; bit++)
+		{
+			if(bitmap[word] & (1 << bit)) return (word*32 + bit);
+		}
+		word++;
+	}
+
+	for(; word < size/32; word++)
+	{
+		if(bitmap[word] != 0)
+		{
+			for(bit = 0; bit < 32; bit++)
+			{
+				if(bitmap[word] & (1 << bit)) return (word*32 + bit);
+			}
+		}
+	}
+	return 0xFFFFFFFF;
+}
 
 ///////////////////////////////////////
@@ -208,36 +145,28 @@
                       uint32_t   size )
 {
-    uint32_t max_word;
 	uint32_t word = index / 32;
 	uint32_t bit  = index % 32;
-    
-    if( index < size )
-    {
-	    if( bit != 0 )
-	    {
-		    for( ; bit < 32; bit++)
-		    {
-			    if( (bitmap[word] & (1 << bit)) == 0) return (word*32 + bit);
-	  	    }
-		    word++;
-	    }
-
-        max_word = ( (size-1) >>5 ) + 1;
-
-        for( ; word < max_word ; word++ )
-	    {
-		    if(bitmap[word] != 0xFFFFFFFF)
-		    {
-			    for(bit = 0 ; bit < 32 ; bit++)
-			    {
-				    if( (bitmap[word] & (1 << bit)) == 0 ) return (word*32 + bit);
-			    }
-            }
-		}
-	}
-
-	return -1;
-
-}  // bitmap_ffc2()
+ 
+	if(bit != 0)
+	{
+		for(; bit < 32; bit++)
+		{
+			if((bitmap[word] & (1 << bit)) == 0) return (word*32 + bit);
+		}
+		word++;
+	}
+
+	for(; word < size/32; word++)
+	{
+		if(bitmap[word] != 0xFFFFFFFF)
+		{
+			for(bit = 0; bit < 32; bit++)
+			{
+				if((bitmap[word] & (1 << bit)) == 0) return (word*32 + bit);
+			}
+		}
+	}
+	return 0xFFFFFFFF;
+}
 
 //////////////////////////////////////
@@ -245,30 +174,19 @@
                      uint32_t   size )
 {
-    uint32_t max_word;
-    uint32_t max_bit;
 	uint32_t word;
 	uint32_t bit;
-
-    if( size )
-    {
-        max_word = ( (size-1) >>5 ) + 1;
-
-        for( word = 0 ; word < max_word ; word++ )
-	    {
-            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
-
-		    if(bitmap[word] != 0)
-		    {
-			    for(bit = 0 ; bit < max_bit ; bit++)
-			    {
-				    if( bitmap[word] & (1 << bit) ) return (word*32 + bit);
-			    }
-            }
-		}
-	}
-
-	return -1;
-
-}  // bitmap_ffs()
+ 
+	for(word = 0 ; word < size/32 ; word++)
+	{
+		if(bitmap[word] != 0)
+		{
+			for(bit = 0 ; bit < 32 ; bit++)
+			{
+				if( bitmap[word] & (1 << bit) ) return (word*32 + bit);
+			}
+		}
+	}
+	return 0xFFFFFFFF;
+}
 
 //////////////////////////////////////
@@ -276,158 +194,18 @@
                      uint32_t   size )
 {
-    uint32_t max_word;
-    uint32_t max_bit;
 	uint32_t word;
 	uint32_t bit;
  
-    if( size )
-    {
-        max_word = ( (size-1) >>5 ) + 1;
-
-        for( word = 0 ; word < max_word ; word++ )
-	    {
-            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
-
-		    if(bitmap[word] != 0XFFFFFFFF)
-		    {
-			    for(bit = 0 ; bit < max_bit ; bit++)
-			    {
-				    if( (bitmap[word] & (1 << bit)) == 0 ) return (word*32 + bit);
-			    }
-            }
-		}
-	}
-
-	return -1;
-
-}  // bitmap_ffc()
-
-
-//////////////////////////////////////////////////////////////////////////////
-//////////////     remote access functions     ///////////////////////////////
-//////////////////////////////////////////////////////////////////////////////
-
-////////////////////////////////////////////
-void bitmap_remote_init( xptr_t   bitmap_xp,
-                         uint32_t len )
-{
-    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
-    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
-
-    uint32_t word;
-    uint32_t nwords = BITMAP_SIZE( len );
-
-    for( word = 0 ; word < nwords ; word++ )
-    {
-        hal_remote_s32( XPTR( bitmap_cxy , &bitmap_ptr[word] ) , 0 );
-    }
-}
-
-////////////////////////////////////////////////////
-inline void bitmap_remote_set( xptr_t     bitmap_xp,
-                               uint32_t   index )
-{
-    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
-    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
-
-	uint32_t  word = index / 32;
-	uint32_t  bit  = index % 32;
-
-    hal_remote_atomic_or( XPTR( bitmap_cxy , &bitmap_ptr[word] ) , (1 <<bit) );
-}
-
-//////////////////////////////////////////////////////
-inline void bitmap_remote_clear( xptr_t     bitmap_xp, 
-                                 uint32_t   index )
-{
-    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
-    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
-
-	uint32_t  word = index / 32;
-	uint32_t  bit  = index % 32;
-
-    hal_remote_atomic_and( XPTR( bitmap_cxy , &bitmap_ptr[word] ) , ~(1 <<bit) );
-}
-
-///////////////////////////////////////////////////
-uint32_t bitmap_remote_alloc( xptr_t     bitmap_xp,
-                              uint32_t   size )
-{
-    uint32_t max_word;
-    uint32_t max_bit; 
-	uint32_t word;
-	uint32_t bit;
-    xptr_t   word_xp;
-    uint32_t value;
- 
-    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
-    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
-
-    if( size )
-    {
-        max_word = ( (size-1) >>5 ) + 1;
-
-        for( word = 0 ; word < max_word ; word++ )
-	    {
-            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
-
-            word_xp = XPTR( bitmap_cxy , &bitmap_ptr[word] );
-
-            value   = hal_remote_l32( word_xp );
-
-		    if( value != 0XFFFFFFFF )
-		    {
-			    for(bit = 0 ; bit < max_bit ; bit++)
-			    {
-				    if( (value & (1 << bit)) == 0 )
-                    {
-                        hal_remote_s32( word_xp , value | (1 << bit) );
-                        return (word*32 + bit);
-                    }
-			    }
-            }
-		}
-	}
-
-	return -1;
-
-}  // end bitmap_alloc()
-
-///////////////////////////////////////////////
-uint32_t bitmap_remote_ffc( xptr_t   bitmap_xp, 
-                                     uint32_t size )
-{
-    uint32_t max_word;
-    uint32_t max_bit;
-	uint32_t word;
-	uint32_t bit;
-    uint32_t value;
- 
-    bitmap_t * bitmap_ptr = GET_PTR( bitmap_xp );
-    cxy_t      bitmap_cxy = GET_CXY( bitmap_xp );
-
-    if( size )
-    {
-        max_word = ( (size-1) >>5 ) + 1;
-
-        for( word = 0 ; word < max_word ; word++ )
-	    {
-            max_bit = (word == (max_word - 1)) ? (size & 0x1F) : 32;
-
-            value = hal_remote_l32( XPTR( bitmap_cxy , &bitmap_ptr[word] ) );
-
-		    if( value != 0xFFFFFFFF )
-		    {
-			    for(bit = 0 ; bit < max_bit ; bit++)
-			    {
-				    if( (value & (1 << bit)) == 0 ) return (word*32 + bit);
-			    }
-            }
-		}
-	}
-
-	return -1;
-
-}  // bitmap_remote_ffc()
-
-
+	for(word = 0 ; word < size/32 ; word++)
+	{
+		if(bitmap[word] != 0)
+		{
+			for(bit = 0 ; bit < 32 ; bit++)
+			{
+				if( (bitmap[word] & (1 << bit)) == 0 ) return (word*32 + bit);
+			}
+		}
+	}
+	return 0xFFFFFFFF;
+}
+
